package de.fraunhofer.iem.dataprovider.taskManager.tasks

sealed class ProcessTask(protected open vararg val flags: String): Task() {

    protected abstract val execPath: String

    override suspend fun execute() {

        val p = ProcessBuilder(execPath, *flags)
            .start()

        p.onExit().thenApply { p1 ->
            handleProcessReturn(p1)
        }

    }

    abstract fun handleProcessReturn(p: Process)
}

class JavaTask(
    override val type: TaskType,
    override val execPath: String,
    override vararg val flags: String,
    val addTask: (task: Task) -> Unit
): ProcessTask() {

    override fun handleProcessReturn(p: Process) {
        addTask(DoneTask("Done with external process. Exit value ${p.exitValue()}"))
    }
}